<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
      <template slot="menuLeft">

      </template>
      <template slot-scope="scope" slot="menu">
        <el-button
          type="text"
          size="small"
          @click="viewErrorMsg(scope.row)"
        >查看错误信息
        </el-button>
        <el-button
          type="text"
          size="small"
          @click="refund(scope.row)"
        >退款
        </el-button>
        <el-button
          type="text"
          size="small"
          @click="refund(scope.row)"
        >补单
        </el-button>
      </template>
    </avue-crud>

    <el-dialog title="错误信息" @close="refreshChange"
               append-to-body
               :visible.sync="messageBox"
               :before-close="messageBox == false"
               width="60%"
               heigh="40%">
          <el-input  v-model="errorMsg" autocomplete="off" :rows="30" type="textarea"></el-input>
<!--        <span>{{errorMsg}}</span>-->
    </el-dialog>
  </basic-container>
</template>

<script>
  import {getList, getDetail, add, update, remove} from "@/api/finance/orderexception";
  import {mapGetters} from "vuex";

  export default {
    data() {
      return {
        errorMsg: '',
        messageBox: false,
        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          height:'auto',
          calcHeight: 30,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          dialogClickModal: false,
          column: [
            {
              label: "订单id",
              prop: "orderId",
              hide: true,
              rules: [{
                required: true,
                message: "请输入订单id",
                trigger: "blur"
              }]
            },
            {
              label: "订单编号",
              prop: "orderNo",
              search: true,
              rules: [{
                required: true,
                message: "请输入订单id",
                trigger: "blur"
              }]
            },
            {
              label: "支付方式",
              prop: "payCodeDesc",
            },
            {
              label: "错误类型",
              prop: "errorTypeDesc",
            },
            {
              label: "错误信息",
              prop: "errorMessage",
              hide: true,
            },
            {
              label: "错误类型 0-其他 1-余额不足 2-订单已取消 3-地区不发货",
              prop: "errorType",
              hide: true,
              rules: [{
                required: true,
                message: "请输入错误类型 0-其他 1-余额不足 2-订单已取消 3-地区不发货",
                trigger: "blur"
              }]
            },

            {
              label: "处理状态",
              prop: "isProcess",
              search: true,
              hide: true,
              type: 'select',
              dicData: [{
                label: '未处理',
                value: 0
              }, {
                label: '已处理',
                value: 1
              }]
            },
            {
              label: "处理状态",
              prop: "processDesc",
            },
            {
              label: "创建时间",
              prop: "createTime",
            },
            {
              label: "处理时间",
              prop: "processTime",
            },
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.orderexception_add, false),
          viewBtn: this.vaildData(this.permission.orderexception_view, false),
          delBtn: this.vaildData(this.permission.orderexception_delete, false),
          editBtn: this.vaildData(this.permission.orderexception_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    methods: {
      rowSave(row, done, loading) {
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      },
      viewErrorMsg(row) {
        this.errorMsg = row.errorMessage;
        this.messageBox = true;
      }
    }
  };
</script>

<style>
</style>
